'use strict';

function objMPUnkDialog() {
  var rc = document.getElementById('rememberChoice');
  if (!rc)
    rc = document.getElementById('alwaysHandle');
  var mode = document.getElementById('mode');
  var basicBox = document.getElementById('basicBox');
  var MD = document.getElementById('md-download-url');
  var DE = document.getElementById('de-download-url');
  var MPBB = document.getElementById('mp-basicbox');
  var BMD = document.getElementById('mp-mddownload');
  var BDE = document.getElementById('mp-dedownload');
  var DefDL = MPIntComm.getPref('DefDL', 'MD');
  var AutoStart = MPIntComm.getPref('AutoStart', false);
  var LastDownload = MPIntComm.getPref('LastDownload', true);
  var IsExt;
  var rcStateD = null;
  var rcStateC;
  var ourcheck;
  var basicmode;
  var BB;
  var Our = false;

  this.Download = function(IsDef) {
    if (IsDef) {
      if (DefDL == 'MD')
        MPIntComm.DownloadMDURL(this.url, this.refe, '', this.fn, this.mime);
      else
        MPIntComm.DownloadDEURL(this.url, this.refe, '', this.fn, this.mime);
    } else {
      if ((basicmode && (BB == BMD)) || (!basicmode && (mode.selectedItem == MD)))
        MPIntComm.DownloadMDURL(this.url, this.refe, '', this.fn, this.mime);
      else
        MPIntComm.DownloadDEURL(this.url, this.refe, '', this.fn, this.mime);
    };
    document.documentElement.removeAttribute('ondialogaccept');
    document.documentElement.cancelDialog();
  }

  this.toggleChoice = function() {
    if ((mode.selectedItem == MD) || (mode.selectedItem == DE)) {
      setTimeout(
        function() {
          document.documentElement.getButton('accept').removeAttribute('disabled')
        },
        0);
      if (rcStateD == null) {
        rcStateD = !rc.getAttribute('disabled');
        rcStateC = rc.checked;
        MPIntComm.SetEnabled(rc, true);
        rc.checked = ourcheck;
      };
    } else if (rcStateD != null) {
      MPIntComm.SetEnabled(rc, rcStateD);
      rcStateD = null;
      ourcheck = rc.checked;
      rc.checked = rcStateC;
    };
  }

  this.processchoice = function() {
    if (basicmode) {
      if (BB.checked) {
        Our = true;
        this.Download(false);
      };
    } else {
      if ((mode.selectedItem == MD) || (mode.selectedItem == DE)) {
        Our = true;
        if (rc.checked)
          MPIntComm.AddExt(this.ext);
        this.Download(false);
      };
    };
    return Our;
  }

  this.Unload = function() {
    MPIntComm.setPref('LastDownload', Our);
  }

  if (MD && !MPIntComm.IsMD)
    MD.setAttribute('hidden', true);
  if (DE && !MPIntComm.IsDE)
    DE.setAttribute('hidden', true);

  basicmode = basicBox && (basicBox.getAttribute('collapsed') != 'true') && MPBB;

  if (MPIntComm.IsMD || MPIntComm.IsDE) {
    this.url = dialog.mLauncher.source.spec;
    this.fn = dialog.mLauncher.suggestedFileName;
    this.mime = dialog.mLauncher.MIMEInfo.MIMEType;
    try {
      this.refe = dialog.mContext
       .QueryInterface(Components.interfaces.nsIWebNavigation).currentURI.spec;
    } catch(ex) {
      this.refe = MPIntComm.getRefe();
    };
    if (!this.refe || (this.refe == 'about:blank')) {
      try {
        this.refe = dialog.mContext
         .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
         .getInterface(Components.interfaces.nsIDOMWindow).document.URL;
      } catch(ex) {}
    };
    if (!this.refe || (this.refe == 'about:blank')) {
      try {
        this.refe = dialog.mContext
         .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
         .getInterface(Components.interfaces.nsIDOMWindow).top.document.URL;
      } catch(ex) {}
    };

    this.ext = '';
    try {
      this.ext = dialog.mLauncher.MIMEInfo.primaryExtension.toLowerCase();
    } catch(ex) {
      let sfname = dialog.mLauncher.suggestedFileName;
      if (sfname) {
        let fext = String(sfname).split('.');
        if (fext.length > 0)
          this.ext = fext[fext.length - 1].toLowerCase();
      };
    };
    IsExt = MPIntComm.InTypes(this.ext) != -1;

    if (AutoStart && IsExt
     && !Application.storage.get('MPIntShiftLastClick', false)) {
      this.Download(true);
    } else {
      document.documentElement.setAttribute('ondialogaccept',
       'if (!MPDownl.processchoice()) { '
       + document.documentElement.getAttribute('ondialogaccept') + '}');

      if (basicmode) {
        MPBB.removeAttribute('collapsed');
        if (MPIntComm.IsMD && MPIntComm.IsDE) {
          BB = DefDL == 'MD' ? BMD : BDE;
        } else if (MPIntComm.IsMD) {
          BB = BMD;
        } else {
          BB = BDE;
        };
        BB.setAttribute('hidden', false);
        if (LastDownload)
          BB.checked = true;
      } else {
        mode.addEventListener('select',
         function(event) {MPDownl.toggleChoice(event)},
         true);
        ourcheck = IsExt;
        if (IsExt || LastDownload) {
          rcStateD = !rc.getAttribute('disabled');
          rcStateC = rc.checked;
          if (DefDL == 'MD') {
            mode.selectedItem = MD;
          } else {
            mode.selectedItem = DE;
          };
          MPIntComm.SetEnabled(rc, true);
          if (ourcheck)
            rc.checked = true;
        };
      };
    };
  };
}

window.addEventListener('load',
  function() {
    MPIntComm.init();
    this.MPDownl = new objMPUnkDialog()
  },
  false);
window.addEventListener('unload',
  function() {
    MPDownl.Unload();
  },
  false);
